"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var application = require("tns-core-modules/application");
function getAppDelegate() {
    if (application.ios.delegate === undefined) {
        var UIApplicationDelegateImpl = (function (_super) {
            __extends(UIApplicationDelegateImpl, _super);
            function UIApplicationDelegateImpl() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            UIApplicationDelegateImpl.new = function () {
                return _super.new.call(this);
            };
            UIApplicationDelegateImpl.ObjCProtocols = [UIApplicationDelegate];
            return UIApplicationDelegateImpl;
        }(UIResponder));
        application.ios.delegate = UIApplicationDelegateImpl;
    }
    return application.ios.delegate;
}
exports.getAppDelegate = getAppDelegate;
function enableMultipleOverridesFor(classRef, methodName, nextImplementation) {
    var currentImplementation = classRef.prototype[methodName];
    classRef.prototype[methodName] = function () {
        var result = currentImplementation && currentImplementation.apply(currentImplementation, Array.from(arguments));
        return nextImplementation.apply(nextImplementation, Array.from(arguments).concat([result]));
    };
}
exports.enableMultipleOverridesFor = enableMultipleOverridesFor;
function setupAppDeligate(urlScheme) {
    var appDelegate = getAppDelegate();
    enableMultipleOverridesFor(appDelegate, 'applicationDidFinishLaunchingWithOptions', function (application, launchOptions) {
        try {
            BTAppSwitch.setReturnURLScheme(urlScheme);
            return true;
        }
        catch (error) {
            console.log(error);
        }
        return false;
    });
    enableMultipleOverridesFor(appDelegate, 'applicationOpenURLSourceApplicationAnnotation', function (application, url, sourceApplication, annotation) {
        try {
            if (url.scheme === urlScheme) {
                BTAppSwitch.handleOpenURLSourceApplication(url, sourceApplication);
                return true;
            }
        }
        catch (error) {
            console.log(error);
        }
        return false;
    });
}
exports.setupAppDeligate = setupAppDeligate;
//# sourceMappingURL=getappdelegate.js.map